<script lang="ts">
  import { createPopper, type VirtualElement } from '@popperjs/core';
  import type { NavLink, NavTab } from '../../interfaces/navigation.interface';
  import { slide } from 'svelte/transition';
  import { isNavLink } from '../../interfaces/navigation.interface.js';
  import Fa from 'svelte-fa';
  import { isAuthenticated, authTokenParsed } from '../../../stores/authStore';
  import { shouldDisplay } from './data/nav-tabs';
  import { Button } from "flowbite-svelte";

  export let navTab: NavTab | NavLink;

  let dropdownPopoverShow = false;
  let btnDropdownRef: Element | VirtualElement;
  let popoverDropdownRef: HTMLElement;

  const toggleDropdown = () => {
    dropdownPopoverShow ? closeDropdown() : openDropdown();
  };

  const closeDropdown = () => {
    dropdownPopoverShow = false;
  };

  const openDropdown = () => {
    dropdownPopoverShow = true;
    createPopper(btnDropdownRef, popoverDropdownRef, {
      placement: 'bottom-start'
    });
  };
</script>

{#if isNavLink(navTab)}
  <li class="flex text-center justify-center">
      <Button
        color="none"
        href={navTab.href}
        data-umami-event="Navbar Link"
        data-umami-event-label="{navTab.label}"
        data-umami-event-href="{navTab.href}"
        class="flex items-center p-2 font-bold text-cyber-blue-900 text-lg uppercase outline-none focus:outline-none hover:text-cyber-blue-500"
        >{navTab.label}</Button>
  </li>
{:else}
  <li class="flex text-center justify-center" on:mouseenter={openDropdown} on:mouseleave={closeDropdown}>
    <button
      class="flex items-center p-2 font-bold text-cyber-blue-900 text-lg uppercase outline-none focus:outline-none"
      bind:this={btnDropdownRef}
      on:click={toggleDropdown}
      >{navTab.label}
      <svg
        xmlns="http://www.w3.org/2000/svg"
        class="h-4 w-4 ml-1 duration-150"
        fill="none"
        viewBox="0 0 24 24"
        stroke="currentColor"
        stroke-width="2"
        transform={dropdownPopoverShow ? 'rotate(-180)' : 'rotate(0)'}>
        <path stroke-linecap="round" stroke-linejoin="round" d="M19 9l-7 7-7-7" />
      </svg></button>
    <ul bind:this={popoverDropdownRef}>
      {#if dropdownPopoverShow}
        <div class="mt-4 text-left drop-shadow-lg" transition:slide>
          <svg xmlns="http://www.w3.org/2000/svg" class="h-4 w-4 ml-4" viewBox="0 0 10 10">
            <polygon points="0 10, 10 10, 5 3, 0 10" fill="white" />
          </svg>
          <div class="bg-white rounded-xl p-4">
            {#key $authTokenParsed}
              {#each navTab.links as link}
                {#if shouldDisplay(link, $isAuthenticated, $authTokenParsed)}
                  <li class="flex flex-row">
                    <Button
                      color="none"
                      data-umami-event="Navbar Link"
                      data-umami-event-label="{link.label}"
                      data-umami-event-href="{link.href}"
                      data-umami-event-target="{link.target}"
                      class="p-1 text-cyber-blue-900 hover:text-cyber-blue-500 font-normal text-base"
                      target={link.target}
                      href={link.href}
                      on:click={closeDropdown}>
                      {#if link.icon}
                        <Fa class="mr-2" icon={link.icon} size="lg" />
                      {/if}
                      {link.label}
                    </Button>
                  </li>
                {/if}
              {/each}
            {/key}
          </div>
        </div>
      {/if}
    </ul>
  </li>
{/if}
